"{ Package: 'jv:vdb' }"

VDBAbstractApplication subclass:#VDBDebuggerConsoleApplication
	instanceVariableNames:'consoleView consoleInput consoleOutput consoleProcess'
	classVariableNames:''
	poolDictionaries:''
	category:'VDB-UI-Console'
!


!VDBDebuggerConsoleApplication class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:VDBConsoleApplication andSelector:#windowSpec
     VDBConsoleApplication new openInterface:#windowSpec
     VDBConsoleApplication open
    "

    <resource: #canvas>

    ^ 
    #(FullSpec
       name: windowSpec
       window: 
      (WindowSpec
         label: 'Debugger Console'
         name: 'Debugger Console'
         min: (Point 10 10)
         bounds: (Rectangle 0 0 782 332)
       )
       component: 
      (SpecCollection
         collection: (
          (ArbitraryComponentSpec
             name: 'Console'
             layout: (LayoutFrame 0 0 0 0 0 1 0 1)
             hasBorder: false
             component: consoleView
           )
          )
        
       )
     )

    "Modified: / 09-06-2014 / 09:57:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBDebuggerConsoleApplication methodsFor:'aspects'!

consoleView
    consoleView isNil ifTrue:[ 
        consoleView :=VDBDebuggerConsoleView new.
        consoleView localEcho:true.
        consoleView inputTranslateCRToNL:true.
        consoleView lineEditMode: true.    
        debugger notNil ifTrue:[ 
            consoleView inStream: consoleInput.
            consoleView outStream: consoleOutput.
            consoleView startReaderProcessWhenVisible.
        ].
    ].
    ^ consoleView

    "Created: / 09-06-2014 / 10:11:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-06-2014 / 01:37:57 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBDebuggerConsoleApplication methodsFor:'event handling'!

onCommandEvent: event

    "Created: / 06-06-2014 / 22:43:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

onCommandResultEvent: event

    "Created: / 06-06-2014 / 22:44:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-06-2014 / 01:33:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

onConsoleOutputEvent: event
    consoleOutput nextPutAll: event value.
    consoleOutput nextPut: Character return.

    "Created: / 06-06-2014 / 21:45:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-06-2014 / 01:33:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

onTargetOutputEvent: event
    consoleOutput nextPutAll: event value.
    consoleOutput nextPut: Character return.

    "Created: / 06-06-2014 / 21:45:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-06-2014 / 01:33:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBDebuggerConsoleApplication methodsFor:'hooks'!

commonPostOpen
    consoleProcess := 
        [
            [
                | cmd |
                consoleOutput nextPutAll:'(gdb) '.
                cmd := consoleInput nextLine asString.
                consoleOutput nextPutLine: cmd.
                consoleOutput nextPut: Character return.
                debugger send: (GDBCLICommand new value: cmd) wait: true. 
            ] loop. 
        ] newProcess.
    consoleProcess name: 'VDB Debugger Console REPL loop'.
    consoleProcess resume.

    "Created: / 10-06-2014 / 01:25:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBDebuggerConsoleApplication methodsFor:'initialization & release'!

initialize
    super initialize.

    consoleInput := VDBInternalPipeStream new.
    consoleOutput := VDBInternalPipeStream new.

    "Created: / 10-06-2014 / 01:23:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

release
    super release.
    consoleProcess terminate.

    "Created: / 10-06-2014 / 01:34:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

subscribe   
    "Register for debugger events. To be overrided by subclasses"

    debugger announcer 
        when: GDBCommandEvent           send: #onCommandEvent:          to: self;
        when: GDBCommandResultEvent     send: #onCommandResultEvent:    to: self;

        when: GDBConsoleOutputEvent     send: #onConsoleOutputEvent:    to: self;
        when: GDBTargetOutputEvent      send: #onTargetOutputEvent:     to: self.

    "Created: / 06-06-2014 / 21:26:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBDebuggerConsoleApplication class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

